ChainLoader:=function(data,n) //Loads a set of pre-formed chains.

NumberToVector:=function(V,n,num)

	v:=Zero(V);

	for i:=1 to n do
		j:=n+1-i;
		if num ge 2^j then v[j]:=1; num-:=2^j; end if;
	end for;
	return v;
end function;


V:=VectorSpace(GF(2),n);


level:=0;
chains:={};
currentseq:=[];

for i:=1 to #data do

	if data[i] gt 0 then
		Append(~currentseq,NumberToVector(V,n,data[i]));
		newlevel:=level;
	else
		if level eq 0 then
			root:=currentseq;
			currentseq:=[];
			branchset:={[Zero(V)]}; Exclude(~branchset,[Zero(V)]);
			newlevel:=1;
				
		else
			if IsEmpty(currentseq) then
				Include(~chains,<root,branchset>);
				newlevel:=0;
			else
				Include(~branchset,currentseq);
				currentseq:=[];
			end if;
		end if;
	end if;

	level:=newlevel;

end for;

return chains;

end function;